
%if 0

Extensions for lDebug link info

Copyright (C) 2008-2023 C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif


%if _LINKHASH
 %include "nasmhash.mac"
%endif

%define LINKINFO_DATA_PREFIXES ""
%define LINKINFO_DATA_ENTRIES ""
%define LINKINFO_DATA_ADDRESSES ""
%define LINKINFO_DATA_MESSAGES db ""
%assign LINKINFO_DATA_AMOUNT 0

%imacro linkinfo_data 1-*.nolist
%push
 %rep %0
  %defstr %$string %1
  %ifn _LINKHASH
   %substr %$prefix %$string 1, 2
   %substr %$suffix %$string 3, -1
   %strlen %$length %$string
   %if %$length < 2
    %fatal Too short link info data name
   %endif
   %if %$length > 63 + 2
    %fatal Too long link info data name
   %endif
   %xdefine LINKINFO_DATA_PREFIXES LINKINFO_DATA_PREFIXES, %$prefix
   %xdefine LINKINFO_DATA_ENTRIES LINKINFO_DATA_ENTRIES, %%message_%1
   %xdefine LINKINFO_DATA_ADDRESSES LINKINFO_DATA_ADDRESSES, %1
   %xdefine LINKINFO_DATA_MESSAGES LINKINFO_DATA_MESSAGES, %%message_%1:, {counted %$suffix}
  %else
   %xdefine %$suffix %$string
hashdef HASH, %$string
   %strlen %$length %$string
   %if %$length > 63 + 2
    %fatal Too long link info data name
   %endif
   %xdefine LINKINFO_DATA_PREFIXES LINKINFO_DATA_PREFIXES, _HASH
   %xdefine LINKINFO_DATA_ENTRIES LINKINFO_DATA_ENTRIES, %%message_%1
   %xdefine LINKINFO_DATA_ADDRESSES LINKINFO_DATA_ADDRESSES, %1
   %xdefine LINKINFO_DATA_MESSAGES LINKINFO_DATA_MESSAGES, %%message_%1:, {counted %$suffix}
  %endif
  %assign LINKINFO_DATA_AMOUNT LINKINFO_DATA_AMOUNT + 1
  %rotate 1
 %endrep
%pop
%endmacro


%define LINKINFO_CODE_PREFIXES ""
%define LINKINFO_CODE_ENTRIES ""
%define LINKINFO_CODE_ADDRESSES ""
%define LINKINFO_CODE_MESSAGES db ""
%assign LINKINFO_CODE_AMOUNT 0

%imacro linkinfo_code 1-*.nolist
%push
 %rep %0
  %if LINKINFO_CODE_SEGMENT == 0
   %define %$section lDEBUG_CODE
  %elif LINKINFO_CODE_SEGMENT == 1
   %define %$section lDEBUG_CODE2
  %elif LINKINFO_CODE_SEGMENT == 2
   %define %$section lDEBUG_DATA_ENTRY
  %else
   %fatal Unknown link info code section
  %endif
  %ifndef SECTION_OF_%1
   %error No section specified for link symbol %1
  %elifnidni SECTION_OF_%1, %$section
   %error Wrong section for link symbol %1: section_of=SECTION_OF_%1, current=%$section
  %endif
  %defstr %$string %1
  %ifn _LINKHASH
   %substr %$prefix %$string 1, 2
   %substr %$suffix %$string 3, -1
   %strlen %$length %$string
   %if %$length < 2
    %fatal Too short link info code name
   %endif
   %if %$length > 63 + 2
    %fatal Too long link info code name
   %endif
   %xdefine LINKINFO_CODE_PREFIXES LINKINFO_CODE_PREFIXES, %$prefix
   %xdefine LINKINFO_CODE_ENTRIES LINKINFO_CODE_ENTRIES, %%message_%1
   %xdefine LINKINFO_CODE_ADDRESSES LINKINFO_CODE_ADDRESSES, %1, LINKINFO_CODE_SEGMENT
   %xdefine LINKINFO_CODE_MESSAGES LINKINFO_CODE_MESSAGES, %%message_%1:, {counted %$suffix}
  %else
   %xdefine %$suffix %$string
hashdef HASH, %$string
   %strlen %$length %$string
   %if %$length > 63 + 2
    %fatal Too long link info code name
   %endif
   %xdefine LINKINFO_CODE_PREFIXES LINKINFO_CODE_PREFIXES, _HASH
   %xdefine LINKINFO_CODE_ENTRIES LINKINFO_CODE_ENTRIES, %%message_%1
   %xdefine LINKINFO_CODE_ADDRESSES LINKINFO_CODE_ADDRESSES, %1, LINKINFO_CODE_SEGMENT
   %xdefine LINKINFO_CODE_MESSAGES LINKINFO_CODE_MESSAGES, %%message_%1:, {counted %$suffix}
  %endif
  %assign LINKINFO_CODE_AMOUNT LINKINFO_CODE_AMOUNT + 1
  %rotate 1
 %endrep
%pop
%endmacro


%imacro dump_linkinfo_messages 1-*.nolist
 %rep %0
	%1
  %rotate 1
 %endrep
%endmacro


%if _MESSAGESEGMENT
 %if _PM
linksel equ messagesel
 %else
linksel equ linkseg
 %endif
linkseg equ messageseg
%else
 %if _PM
linksel equ dssel
 %else
linksel equ linkseg
 %endif
linkseg equ pspdbg
%endif

linkinfo_data linksel
linkinfo_data linkseg
linkinfo_data linkinfoaddress
linkinfo_data linkcall_table
linkinfo_data extseg, extcssel, extdssel, extseg_size, extseg_used
linkinfo_data extdata, extdata_size, extdata_used
linkinfo_data pspdbg, pspdbe
linkinfo_data internalflags
linkinfo_data internalflags2
linkinfo_data internalflags3
linkinfo_data internalflags4
linkinfo_data internalflags5
linkinfo_data internalflags6
linkinfo_data options
linkinfo_data options2
linkinfo_data options3
linkinfo_data options4
linkinfo_data options5
linkinfo_data options6
linkinfo_data lastcmd
linkinfo_data line_in, line_out, line_out_end
linkinfo_data auxbuff_segorsel
linkinfo_data auxbuff_current_size, auxbuff_current_size_minus_24
linkinfo_data firstmcb, firstumcb
;linkinfo_data 


%assign LINKINFO_CODE_SEGMENT 0		; CODE1
linkinfo_code puts, putsz, putc, putsline, putsline_crlf, trimputs
linkinfo_code skipcomma, skipcomm0, skipwhite, skipwh0
linkinfo_code isstring?, uppercase, chkeol, iseol?
linkinfo_code guard_auxbuff, guard_re, prephack, dohack, unhack
linkinfo_code handle_serial_flags_ctrl_c
linkinfo_code hexbyte, hexword, hexword_high
linkinfo_code ispm, setes2dx, call_int2D
linkinfo_code copy_single_counted_string
linkinfo_code intchk
linkinfo_code IsIISPEntry?
;linkinfo_code 

%if _DUALCODE && _EXPRDUALCODE
 %assign LINKINFO_CODE_SEGMENT 1	; CODE2
%else
 %assign LINKINFO_CODE_SEGMENT 0	; CODE1
%endif
linkinfo_code isvariable?, isseparator?, get_value_range
linkinfo_code getexpression, getdword, getword, getbyte
linkinfo_code getaddr, getaddrX, getrange, getrangeX
;linkinfo_code 


	align 4, db 0
linkinfo:
	dw 0E1D0h, 0, 0
	dw !!_LINKHASH
	dw LINKINFO_DATA_AMOUNT
	dw linkinfo_data_table_prefixes
	dw linkinfo_data_table_entries
	dw linkinfo_data_table_addresses
	dw LINKINFO_CODE_AMOUNT
	dw linkinfo_code_table_prefixes
	dw linkinfo_code_table_entries
	dw linkinfo_code_table_addresses


	align 2, db 0
linkinfo_data_table_prefixes:
.:	dw LINKINFO_DATA_PREFIXES
.amount equ ($ - .) / 2
%if .amount != LINKINFO_DATA_AMOUNT
 %error Unexpected table size
%endif

	align 2, db 0
linkinfo_data_table_entries:
.:	dw LINKINFO_DATA_ENTRIES
.amount equ ($ - .) / 2
%if .amount != LINKINFO_DATA_AMOUNT
 %error Unexpected table size
%endif

	align 2, db 0
linkinfo_data_table_addresses:
.:	dw LINKINFO_DATA_ADDRESSES
.amount equ ($ - .) / 2
%if .amount != LINKINFO_DATA_AMOUNT
 %error Unexpected table size
%endif


	align 2, db 0
linkinfo_code_table_prefixes:
.:	dw LINKINFO_CODE_PREFIXES
.amount equ ($ - .) / 2
%if .amount != LINKINFO_CODE_AMOUNT
 %error Unexpected table size
%endif

	align 2, db 0
linkinfo_code_table_entries:
.:	dw LINKINFO_CODE_ENTRIES
.amount equ ($ - .) / 2
%if .amount != LINKINFO_CODE_AMOUNT
 %error Unexpected table size
%endif

	align 2, db 0
linkinfo_code_table_addresses:
.:	dw LINKINFO_CODE_ADDRESSES
.amount equ ($ - .) / 4
%if .amount != LINKINFO_CODE_AMOUNT
 %error Unexpected table size
%endif


	dump_linkinfo_messages LINKINFO_DATA_MESSAGES, LINKINFO_CODE_MESSAGES
